local dn = daynightcycle


rawset(_G, "werehogtransformvoice", werehogtransformvoice or {})
rawset(_G, "classicskins", classicskins or {})
rawset(_G, "nonsonicsonics", nonsonicsonics or {})
rawset(_G, "earlesssonic", earlesssonic or {})


freeslot(
	"spr_wfog",
	"S_WEREHOGFOG",
	"MT_WEREHOGFOG",
	"sfx_whogry",
	"sfx_whogro",
	"sfx_whogja",
	"sfx_whoghg"
)

mobjinfo[MT_WEREHOGFOG] = {
	doomednum = -1,
	spawnstate = S_WEREHOGFOG,
	flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_WEREHOGFOG] = {
	sprite = SPR_WFOG,
	frame = A|FF_ANIMATE|TR_TRANS40,
	var1 = 7,
	var2 = 2,
	tics = 7*2,
	nextstate = S_NULL
}


local werehogenabled = true


//Check if you're Sonic or not. May or may not be stolen from SMS.
local function CanBecomeWerehog(s)
	if s and s.skin
		if (( (string.find(s.skin, "sonic") and not string.find(s.skin, "metal") and not string.find(s.skin, "mecha") and not string.find(s.skin, "hard")) ) 
		/*or (s.skin == "greeneyes") or (s.skin == "sunky") or (s.skin == "earless") or (s.skin == "earlessredo")
		or (s.skin == "3dson") or (s.skin == "handdrawn") or (s.skin == "pointy") or (s.skin == "sonik") or (s.skin == "bandages")*/
		or nonsonicsonics[s.skin] 
		or earlesssonic[s.skin])
		and (werehogenabled and werehogenabled == true)
			return true //Everyone is Sonic, and since everyone is Sonic, EVERYONE IS SMS- er, I mean WEREHOG.
		end
	end
	return false
end

function dn.werewolfPlayerThink(p)
	--if (p.cmd.buttons & BT_CUSTOM1)
		if skins["werehog"]
			--print("weg")
			--if CanBecomeWerehog(p.mo)
				--print(CanBecomeWerehog(p.mo))
			--end

			if CanBecomeWerehog(p.mo) and not dn.isDayHalf() and not (p.WerehogTimer and p.WerehogTimer > 0)
				p.WerehogStoredSkin = p.mo.skin	
				p.WerehogTimer = TICRATE*4
				p.WerehogReversion = true
				--R_SetPlayerSkin(p, "werehog")
			end

			if p.mo.skin == "werehog" and dn.isDayHalf() and not (p.WerehogTimer and p.WerehogTimer > 0)
				--if p.WerehogStoredSkin
					--R_SetPlayerSkin(p, p.WerehogStoredSkin)
				--else
					--R_SetPlayerSkin(p, "sonic")
				--end
				p.WerehogTimer = TICRATE*10
				p.WerehogReversion = false
			end
	--	else
			--print("nah")
		end

	if (p.WerehogTimer and p.WerehogTimer > 0)
		p.WerehogTimer = $-1
		if P_RandomRange(5, 0) == 2 or p.WerehogTimer <= 2*TICRATE
			local fog = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_WEREHOGFOG)
			fog.blendmode = AST_SUBTRACT
			fog.targ = p.mo
			fog.xoff = P_RandomRange(23, -23)*p.mo.scale
			fog.yoff = P_RandomRange(23, -23)*p.mo.scale
			fog.zoff = P_RandomRange(23, -23)*p.mo.scale+p.mo.height*P_MobjFlip(p.mo)/3
			fog.scale = p.mo.scale+P_RandomRange(-2, 3)*p.mo.scale/8

			if P_RandomRange(0, 4) == 4
				fog.falloff = true
			end
		end

		if (p.WerehogTimer == 1)
			p.WerehogTransformation = FRACUNIT*3
			--print(leveltime)
			if (p.mo.skin == "werehog")
				if p.WerehogStoredSkin
					R_SetPlayerSkin(p, p.WerehogStoredSkin)
				else
					R_SetPlayerSkin(p, "sonic")
				end

				if classicskins[p.mo.skin]
				or earlesssonic[p.mo.skin]
					S_StartSound(p.mo, sfx_cdpcm2)
				elseif werehogtransformvoice[p.mo.skin] and werehogtransformvoice[p.mo.skin] == "ryan"
					S_StartSound(p.mo, sfx_whogry)
				elseif werehogtransformvoice[p.mo.skin] and werehogtransformvoice[p.mo.skin] == "roger"
					S_StartSound(p.mo, sfx_whogro)
				else
					S_StartSound(p.mo, sfx_whogja)
				end
				P_ResetPlayer(p)
			else
				R_SetPlayerSkin(p, "werehog")
				S_StartSound(p.mo, sfx_whoghg)
				P_ResetPlayer(p)
			end
		end
	end
	
	if p.WerehogTransformation and p.WerehogTransformation > 0
		if p.WerehogTransformation > FRACUNIT-FRACUNIT/4
			p.WerehogTransformation = $-FRACUNIT/7
		elseif p.WerehogTransformation < FRACUNIT/2
			p.WerehogTransformation = $-FRACUNIT/10
		else
			p.WerehogTransformation = $-FRACUNIT/30
			--print(leveltime)
		end
		p.WerehogTransformation = max($, 0)
	end

	/*if (p.cmd.buttons & BT_CUSTOM1)
		local fog = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_WEREHOGFOG)
		fog.blendmode = AST_SUBTRACT
		fog.targ = p.mo
		fog.xoff = P_RandomRange(23, -23)*p.mo.scale
		fog.yoff = P_RandomRange(23, -23)*p.mo.scale
		fog.zoff = P_RandomRange(23, -23)*p.mo.scale+p.mo.height*P_MobjFlip(p.mo)/3
		fog.scale = p.mo.scale+P_RandomRange(-2, 3)*p.mo.scale/8
		p.WerehogTransformation = FRACUNIT*3
		if (p.cmd.buttons & BT_CUSTOM2)
			p.WerehogReversion = true
		end
		if P_RandomRange(0, 4) == 4
			fog.falloff = true
		end
	end*/
end


addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.health) return end --just make sure it still fucking exists

	if mo.targ and mo.targ.valid and mo.targ.health --make sure player exists and is alive
		if not (mo.falloff and mo.tics != 7*2)
			P_TeleportMove(mo, mo.targ.x+mo.xoff, mo.targ.y+mo.yoff, mo.targ.z+mo.zoff)
		elseif (mo.falloff)
			mo.momz = mo.targ.momz/2
			mo.momx = mo.targ.momx/2
			mo.momy = mo.targ.momy/2
		end
	else--if player is dead
		P_RemoveMobj(mo)
	end
end, MT_WEREHOGFOG)

COM_AddCommand("werehogtransform", function(player, arg)
	if werehogenabled != nil and arg
		if arg == "true" or arg == "on" or arg == "1"
			werehogenabled = true
			print("Dark Gaia's influence grows stronger...")
		elseif  arg == "false" or arg == "off" or arg == "0"
			werehogenabled = false
			print("Dark Gaia's power wanes...")
		end
	end
end, COM_ADMIN)

hud.add(function(v, p)
    if not (p.mo and p.WerehogTransformation and p.WerehogTransformation != 0) return end

	local prefix
	if (p.WerehogReversion)
		prefix = "WHOGR"
	elseif (classicskins[p.mo.skin])
		prefix = "VSONW"
	elseif (earlesssonic[p.mo.skin])
		prefix = "EARLS"
	else
		prefix = "MSONW"
	end

	local x = 160*FRACUNIT
	local y = 100*FRACUNIT
	local scale = p.WerehogTransformation --max((FRACUNIT*3)-((FRACUNIT/40)*p.WerehogTransformation), 1)
	v.drawScaled(x, y, scale, v.cachePatch(prefix .. "3"), V_80TRANS)
	v.drawScaled(x, y, scale, v.cachePatch(prefix .. "2"), V_60TRANS)
	v.drawScaled(x, y, scale, v.cachePatch(prefix .. "1"))
end, "game")
